//
//  FeedController.m
//  PetTrainerFinal
//
//  Created by Tomomasa Terazaki on 3/31/10.
//  Copyright 2010 UC Berkeley. All rights reserved.
//

#import "FeedController.h"
#import "Food.h"

@implementation FeedController

@synthesize ptf, nav, fp, nf, fh, arryData;

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	[arryData count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	static NSString *CellIdentifier = @"Cell";
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
	}
	cell.text = [arryData objectAtIndex:indexPath.row];
	[cell setAccessoryType:UITableViewCellAccessoryDisclosureIndicator];
	return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	self.ptf.foodname = [arryData objectAtIndex:indexPath.row];
	[self.nav pushViewController:fp animated:YES];
	[fp show];
	[fh.foodData addObject:ptf.foodname];
	//[fh saveFoodHistory];
	[ptf.localData setObject:fh.foodData forKey:@"foodData"];
	[fh reloading];
	ptf.petnews = [[NSString alloc] initWithFormat:@"%@ consumed %@\n%@", ptf.petname, ptf.foodname, ptf.petnews];
	[ptf.localData setObject:ptf.petnews forKey:@"petnews"];
	[ptf.localData setObject:ptf.petmood forKey:@"petmood"];
	for (Food *foodTemp in ptf.foodList) {
		if ([ptf.foodname compare:foodTemp.name] == 0) {
			ptf.totalCalories += foodTemp.calories;
			int goal;
			if (ptf.walkHappiness == 0) {
				goal = [ptf.petweight intValue] * 11;
			}
			else if (ptf.walkHappiness == 1) {
				goal = [ptf.petweight intValue] * 12;
			}
			else if (ptf.walkHappiness == 2) {
				goal = [ptf.petweight intValue] * 13;
			}
			else if (ptf.walkHappiness == 3) {
				goal = [ptf.petweight intValue] * 14;
			}
			else if (ptf.walkHappiness == 4) {
				goal = [ptf.petweight intValue] * 15;
			}
			else if (ptf.walkHappiness == 5) {
				goal = [ptf.petweight intValue] * 16;
			}
			if (ptf.totalCalories < (goal / 2)) {
				ptf.eatHappiness = 0;
				ptf.peteatmood = @" and eat a lot more";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > (goal / 2) && ptf.totalCalories < goal * 0.6) {
				ptf.eatHappiness = 1;
				ptf.peteatmood = @" and eat more";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > goal * 0.6 &&  ptf.totalCalories < goal * 0.7) {
				ptf.eatHappiness = 2;
				ptf.peteatmood = @" and eat more";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > goal * 0.7 &&  ptf.totalCalories < goal * 0.8) {
				ptf.eatHappiness = 3;
				ptf.peteatmood = @" and eat little more";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > goal * 0.0 &&  ptf.totalCalories < goal * 0.9) {
				ptf.eatHappiness = 4;
				ptf.peteatmood = @" and eat little more";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > goal * 0.9 &&  ptf.totalCalories < goal * 1.1) {
				ptf.eatHappiness = 5;
				ptf.peteatmood = @" and ate perfect amount";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > goal * 1.1 &&  ptf.totalCalories < goal * 1.3) {
				ptf.eatHappiness = 3;
				ptf.peteatmood = @" and doesn't want to eat";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > goal * 1.3) {
				ptf.eatHappiness = 0;
				ptf.peteatmood = @" and ate too much";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}			
		}
	}
  [ptf.localData setInteger:ptf.totalCalories forKey:@"totalCalories"];
}

-(IBAction) goNewFood {
	[self.nav pushViewController:nf animated:YES];
	nf.existence.text = @"";
}

-(IBAction) goFoodHistory {
	[fh change];
	[self.nav pushViewController:fh animated:YES];
}

-(void) reloading {
	[tblSimpleTable reloadData];
	int goal;
	if (ptf.walkHappiness == 0) {
		goal = [ptf.petweight intValue] * 11;
	}
	else if (ptf.walkHappiness == 1) {
		goal = [ptf.petweight intValue] * 12;
	}
	else if (ptf.walkHappiness == 2) {
		goal = [ptf.petweight intValue] * 13;
	}
	else if (ptf.walkHappiness == 3) {
		goal = [ptf.petweight intValue] * 14;
	}
	else if (ptf.walkHappiness == 4) {
		goal = [ptf.petweight intValue] * 15;
	}
	else if (ptf.walkHappiness == 5) {
		goal = [ptf.petweight intValue] * 16;
	}
	if (ptf.totalCalories < (goal / 2)) {
		ptf.eatHappiness = 0;
		ptf.peteatmood = @" and eat a lot more";
		[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
	}
	else if (ptf.totalCalories > (goal / 2) && ptf.totalCalories < goal * 0.6) {
		ptf.eatHappiness = 1;
		ptf.peteatmood = @" and eat more";
		[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
	}
	else if (ptf.totalCalories > goal * 0.6 &&  ptf.totalCalories < goal * 0.7) {
		ptf.eatHappiness = 2;
		ptf.peteatmood = @" and eat more";
		[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
	}
	else if (ptf.totalCalories > goal * 0.7 &&  ptf.totalCalories < goal * 0.8) {
		ptf.eatHappiness = 3;
		ptf.peteatmood = @" and eat little more";
		[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
	}
	else if (ptf.totalCalories > goal * 0.0 &&  ptf.totalCalories < goal * 0.9) {
		ptf.eatHappiness = 4;
		ptf.peteatmood = @" and eat little more";
		[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
	}
	else if (ptf.totalCalories > goal * 0.9 &&  ptf.totalCalories < goal * 1.1) {
		ptf.eatHappiness = 5;
		ptf.peteatmood = @" and ate perfect amount";
		[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
	}
	else if (ptf.totalCalories > goal * 1.1 &&  ptf.totalCalories < goal * 1.3) {
		ptf.eatHappiness = 3;
		ptf.peteatmood = @" and doesn't want to eat";
		[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
	}
	else if (ptf.totalCalories > goal * 1.3) {
		ptf.eatHappiness = 0;
		ptf.peteatmood = @" and ate too much";
		[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
	}	
}

-(void) saveData {
	[NSKeyedArchiver archiveRootObject:[arryData copy] toFile:[self dataFilePath]];
}

-(void) tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle) edittingSytle forRowAtIndexPath: (NSIndexPath *) indexPath {
	[arryData removeObjectAtIndex:indexPath.row];
	[ptf.foodList removeObjectAtIndex:indexPath.row];
	[ptf saveFoodList];
	[tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationLeft];
}

-(NSString *) dataFilePath {
	NSString *dataFilePath;
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentDirectory = [paths objectAtIndex:0];
	dataFilePath = [[documentDirectory stringByAppendingPathComponent:@"applicationData.plist"] retain];
	return dataFilePath;
}

-(void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
	NSString *item = [[arryData objectAtIndex:fromIndexPath.row] retain];
	[arryData removeObject:item];
	[arryData insertObject:item atIndex:toIndexPath.row];
	[item release];
}

- (void)motionBegan:(UIEventSubtype)motion withEvent:(UIEvent *)event {
    if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
      [ptf updateCurrentSteps];
    }
}

- (void)motionEnded:(UIEventSubtype)motion withEvent:(UIEvent *)event {
  if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
		[ptf updateHappiness];
	}
}

- (void) viewDidAppear:(BOOL)animated {
    [self becomeFirstResponder];
    [super viewDidAppear:animated];
}

-(BOOL) canBecomeFirstResponder {
	return YES;
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	[self.view addSubview:[nav view]];
	self.ptf = (PetTrainerFinalAppDelegate *) [[UIApplication sharedApplication] delegate];
	fp = [[FeedPic alloc] init];
	fp.navBefore = nav;
	fp.pageBefore = self;
	nf = [[NewFood alloc] init];
	nf.navBefore = nav;
	nf.pageBefore = self;
	fh = [[FoodHistory alloc] init];
	fh.navBefore = nav;
	fh.pageBefore = self;
	fh.foodData = [[NSMutableArray alloc] initWithObjects: nil];
	if ([ptf.localData stringArrayForKey:@"foodData"] != nil) {
		//[fh loadFoodHistory];
		[fh.foodData setArray:[ptf.localData stringArrayForKey:@"foodData"]];
	} else {
		//[fh saveFoodHistory];
		[ptf.localData setObject:fh.foodData forKey:@"foodData"];
	}
	/*arryData = [[NSMutableArray alloc] initWithObjects:@"Apple", @"Avocado", @"Banana", @"Cheddar Cheese (1 Slice)", 
				@"Colby Cheese (1 Slice)", @"Egg", @"Grape", @"Grapefruit", @"Kiwi", @"Mango", @"Melon", @"Milk (0%)", 
				@"Milk (1%)", @"Milk (2%)", @"Orange", @"Peach", @"Pear", @"Pinapple", @"Pizza (Cheese 1 Slice)", 
				@"Pizza (Pepperoni 1 Slice)", @"Plum", @"Strawberry", @"Watermelon", nil];*/
	arryData = [[NSMutableArray alloc] initWithObjects: nil];
	for (Food *foodTemp in ptf.foodList) {
		[arryData addObject:foodTemp.name];
	}
	[super viewDidLoad];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
