//
//  FeedPic.m
//  PetTrainerFinal
//
//  Created by Tomomasa Terazaki on 4/1/10.
//  Copyright 2010 UC Berkeley. All rights reserved.
//

#import "FeedPic.h"

@implementation FeedPic

@synthesize ptf, pageBefore, navBefore, eating, hsc;

@synthesize animation;

-(IBAction) goBack {
	[self.navBefore popViewControllerAnimated:YES];
}

-(void) show {
	if (ptf.petname == NULL) {
		ptf.petname = @"David";
	}
	eating.text =  [[NSString alloc] initWithFormat:@"%@ consumed %@!", ptf.petname, ptf.foodname];
	
	UIImageView *images = [UIImageView alloc];
	[images initWithFrame:[self.animation bounds]];
		
	NSArray *myImages = [NSArray arrayWithObjects:
						 [UIImage imageNamed:@"eatPic1.png"],
						 [UIImage imageNamed:@"eatPic2.png"],
						 nil];
	images.animationImages = myImages;
	images.animationDuration = 0.8;
	[images startAnimating];
	[self.animation addSubview:images];
	
	[images release];
	self.animation = nil;	
}

- (void)motionBegan:(UIEventSubtype)motion withEvent:(UIEvent *)event {
    if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
      [ptf updateCurrentSteps];
    }
}

- (void)motionEnded:(UIEventSubtype)motion withEvent:(UIEvent *)event {
  if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
		[ptf updateHappiness];
	}
}
- (void) viewDidAppear:(BOOL)animated {
    [self becomeFirstResponder];
    [super viewDidAppear:animated];
}

-(BOOL) canBecomeFirstResponder {
	return YES;
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	self.ptf = (PetTrainerFinalAppDelegate *) [[UIApplication sharedApplication] delegate];
    [super viewDidLoad];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
