//
//  FoodHistory.m
//  PetTrainerFinal
//
//  Created by Tomomasa Terazaki on 4/1/10.
//  Copyright 2010 UC Berkeley. All rights reserved.
//

#import "FoodHistory.h"
#import "FeedController.h"
#import "Food.h"

@implementation FoodHistory

@synthesize ptf, pageBefore, navBefore, foodData, fi, tblSimpleTable, totCalories;

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	[foodData count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	static NSString *CellIdentifier = @"Cell";
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
	}
	cell.text = [foodData objectAtIndex:indexPath.row];
	[cell setAccessoryType:UITableViewCellAccessoryDisclosureIndicator];
	return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	self.ptf.tempFood = [foodData objectAtIndex:indexPath.row];
	[self presentModalViewController:fi animated:YES];
	[fi refresh];
}

-(IBAction) goBack {
	[self.navBefore popViewControllerAnimated:YES];
}

-(void) reloading {
	[tblSimpleTable reloadData];
}

-(void) change {
	int goal;
	if (ptf.walkHappiness == 0) {
		goal = [ptf.petweight intValue] * 11;
	}
	else if (ptf.walkHappiness == 1) {
		goal = [ptf.petweight intValue] * 12;
	}
	else if (ptf.walkHappiness == 2) {
		goal = [ptf.petweight intValue] * 13;
	}
	else if (ptf.walkHappiness == 3) {
		goal = [ptf.petweight intValue] * 14;
	}
	else if (ptf.walkHappiness == 4) {
		goal = [ptf.petweight intValue] * 15;
	}
	else if (ptf.walkHappiness == 5) {
		goal = [ptf.petweight intValue] * 16;
	}
	totCalories.text = [[NSString alloc] initWithFormat:@"Total Calories: \nGoal: %d", goal];
}
	
-(void) saveData {
	[NSKeyedArchiver archiveRootObject:[foodData copy] toFile:[self dataFilePath]];
}

-(void) tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle) edittingSytle forRowAtIndexPath: (NSIndexPath *) indexPath {
	NSString *item = [[foodData objectAtIndex:indexPath.row] retain];
	for (Food *foodTemp in ptf.foodList) {
		if ([item compare:foodTemp.name] == 0) {
			ptf.totalCalories -= foodTemp.calories;
			int goal;
			if (ptf.walkHappiness == 0) {
				goal = [ptf.petweight intValue] * 11;
			}
			else if (ptf.walkHappiness == 1) {
				goal = [ptf.petweight intValue] * 12;
			}
			else if (ptf.walkHappiness == 2) {
				goal = [ptf.petweight intValue] * 13;
			}
			else if (ptf.walkHappiness == 3) {
				goal = [ptf.petweight intValue] * 14;
			}
			else if (ptf.walkHappiness == 4) {
				goal = [ptf.petweight intValue] * 15;
			}
			else if (ptf.walkHappiness == 5) {
				goal = [ptf.petweight intValue] * 16;
			}
			if (ptf.totalCalories < (goal / 2)) {
				ptf.eatHappiness = 0;
				ptf.peteatmood = @" and eat a lot more";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > (goal / 2) && ptf.totalCalories < goal * 0.6) {
				ptf.eatHappiness = 1;
				ptf.peteatmood = @" and eat more";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > goal * 0.6 &&  ptf.totalCalories < goal * 0.7) {
				ptf.eatHappiness = 2;
				ptf.peteatmood = @" and eat more";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > goal * 0.7 &&  ptf.totalCalories < goal * 0.8) {
				ptf.eatHappiness = 3;
				ptf.peteatmood = @" and eat little more";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > goal * 0.0 &&  ptf.totalCalories < goal * 0.9) {
				ptf.eatHappiness = 4;
				ptf.peteatmood = @" and eat little more";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > goal * 0.9 &&  ptf.totalCalories < goal * 1.1) {
				ptf.eatHappiness = 5;
				ptf.peteatmood = @" and ate perfect amount";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > goal * 1.1 &&  ptf.totalCalories < goal * 1.3) {
				ptf.eatHappiness = 3;
				ptf.peteatmood = @" and doesn't want to eat";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}
			else if (ptf.totalCalories > goal * 1.3) {
				ptf.eatHappiness = 0;
				ptf.peteatmood = @" and ate too much";
				[ptf.localData setObject:ptf.peteatmood forKey:@"peteatmood"];
				ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			}			
			[ptf.localData setInteger:ptf.totalCalories forKey:@"totalCalories"];
		}
	}
	[foodData removeObjectAtIndex:indexPath.row];
	[tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationLeft];
	[item release];
	
	ptf.petnews = [[NSString alloc] initWithFormat:@"%@ regurgitated %@\n%@", ptf.petname, ptf.foodname, ptf.petnews];
  [ptf.localData setObject:ptf.petnews forKey:@"petnews"];
	//[self saveFoodHistory];
	[ptf.localData setObject:foodData forKey:@"foodData"];
}
	
-(NSString *) dataFilePath {
	NSString *dataFilePath;
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentDirectory = [paths objectAtIndex:0];
	dataFilePath = [[documentDirectory stringByAppendingPathComponent:@"applicationData.plist"] retain];
	return dataFilePath;
}

-(void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
	NSString *item = [[foodData objectAtIndex:fromIndexPath.row] retain];
	for (Food *foodTemp in ptf.foodList) {
		if (item == foodTemp.name) {
			ptf.totalCalories -= foodTemp.calories;
      [ptf.localData setInteger:ptf.totalCalories forKey:@"totalCalories"];
		}
	}
	[foodData removeObject:item];
	[foodData insertObject:item atIndex:toIndexPath.row];
	//[self saveFoodHistory];
	[ptf.localData setObject:foodData forKey:@"foodData"];
	[item release];
}

-(IBAction) calculate {
	int goal;
	if (ptf.walkHappiness == 0) {
		goal = [ptf.petweight intValue] * 11;
	}
	else if (ptf.walkHappiness == 1) {
		goal = [ptf.petweight intValue] * 12;
	}
	else if (ptf.walkHappiness == 2) {
		goal = [ptf.petweight intValue] * 13;
	}
	else if (ptf.walkHappiness == 3) {
		goal = [ptf.petweight intValue] * 14;
	}
	else if (ptf.walkHappiness == 4) {
		goal = [ptf.petweight intValue] * 15;
	}
	else if (ptf.walkHappiness == 5) {
		goal = [ptf.petweight intValue] * 16;
	}
	totCalories.text = [[NSString alloc] initWithFormat:@"Total Calories: %d Calories\nGoal: %d", ptf.totalCalories, goal];
}

-(void) loadFoodHistory {
	[foodData setArray:[ptf.localData stringArrayForKey:@"foodData"]];
	NSLog(@"loading food history");
	for (NSString *name in foodData) {
		NSLog(name);
	}
}

-(void) saveFoodHistory {
	[ptf.localData setObject:foodData forKey:@"foodData"];
	NSLog(@"saving food history");
	for (NSString *name in foodData) {
		NSLog(name);
	}
	[foodData setArray:[ptf.localData stringArrayForKey:@"foodData"]];
	NSLog(@"checking food history");
	for (NSString *name in foodData) {
		NSLog(name);
	}
}

- (void)motionBegan:(UIEventSubtype)motion withEvent:(UIEvent *)event {
    if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
      [ptf updateCurrentSteps];
    }
}

- (void)motionEnded:(UIEventSubtype)motion withEvent:(UIEvent *)event {
  if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
		[ptf updateHappiness];
	}
}

- (void) viewDidAppear:(BOOL)animated {
    [self becomeFirstResponder];
    [super viewDidAppear:animated];
}

-(BOOL) canBecomeFirstResponder {
	return YES;
}	

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	self.ptf = (PetTrainerFinalAppDelegate *) [[UIApplication sharedApplication] delegate];
	fi = [[FoodInfo alloc] init];
    [super viewDidLoad];
	int goal;
	if (ptf.walkHappiness == 0) {
		goal = [ptf.petweight intValue] * 11;
	}
	else if (ptf.walkHappiness == 1) {
		goal = [ptf.petweight intValue] * 12;
	}
	else if (ptf.walkHappiness == 2) {
		goal = [ptf.petweight intValue] * 13;
	}
	else if (ptf.walkHappiness == 3) {
		goal = [ptf.petweight intValue] * 14;
	}
	else if (ptf.walkHappiness == 4) {
		goal = [ptf.petweight intValue] * 15;
	}
	else if (ptf.walkHappiness == 5) {
		goal = [ptf.petweight intValue] * 16;
	}
	totCalories.text = [[NSString alloc] initWithFormat:@"Total Calories: \nGoal: %d", goal];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
