//
//  FoodInfo.m
//  PetTrainerFinal
//
//  Created by Tomomasa Terazaki on 4/2/10.
//  Copyright 2010 UC Berkeley. All rights reserved.
//

#import "FoodInfo.h"
#import "Food.h"

@implementation FoodInfo

@synthesize ptf, foodName, foodCalories, nf;

-(IBAction) goBack {
	[self dismissModalViewControllerAnimated:YES];
}

-(void) refresh {
	NSString *tempURL = [NSString stringWithFormat:@"http://www.bing.com/search?q=%@+information", ptf.tempFood];
	tempURL = [tempURL stringByReplacingOccurrencesOfString:@" " withString:@"+"];
	
	// loading the content from a URLNSURL
	NSURL *url = [NSURL URLWithString:tempURL];
	NSURLRequest *request = [NSURLRequest requestWithURL:url];
	[loading startAnimating];
	[webView loadRequest:request];
}

-(void) viewWillAppear:(BOOL)animated {
	for (Food *foodTemp in ptf.foodList) {
		if ([ptf.tempFood compare:foodTemp.name] == 0) {
			foodName.text = foodTemp.name;
			foodCalories.text = [[NSString alloc] initWithFormat:@"%d calories", foodTemp.calories];
		}
	}
}

- (void)motionBegan:(UIEventSubtype)motion withEvent:(UIEvent *)event {
    if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
      [ptf updateCurrentSteps];
    }
}

- (void)motionEnded:(UIEventSubtype)motion withEvent:(UIEvent *)event {
  if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
		[ptf updateHappiness];
	}
}

- (void) viewDidAppear:(BOOL)animated {
    [self becomeFirstResponder];
    [super viewDidAppear:animated];
}

-(BOOL) canBecomeFirstResponder {
	return YES;
}
	
- (void)webViewDidFinishLoad:(UIWebView *)someWebView {
	if (someWebView == webView) {
		[loading stopAnimating];
	}
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	self.ptf = (PetTrainerFinalAppDelegate *) [[UIApplication sharedApplication] delegate];
    [super viewDidLoad];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
