//
//  NewFood.m
//  PetTrainerFinal
//
//  Created by Tomomasa Terazaki on 4/1/10.
//  Copyright 2010 UC Berkeley. All rights reserved.
//

#import "NewFood.h"
#import "FeedController.h"
#import "Food.h"
 
@implementation NewFood

@synthesize ptf, pageBefore, navBefore, name, calories, googleSearch, existence, nfs;

-(IBAction) goBack {
	Food *temp = [[Food alloc] init];
	temp.name = name.text;
	temp.calories = [calories.text intValue];
	int counter = 0;
	BOOL exist = NO;
	while (counter <= [pageBefore.arryData count]) {
		if (counter == [pageBefore.arryData count]) {
			[pageBefore.arryData addObject: temp.name];
			[ptf.foodList addObject:temp];
			counter = [pageBefore.arryData count] + 1;
		}
		else if ([temp.name compare: [pageBefore.arryData objectAtIndex:counter]] == 0) {
			exist = YES;
			counter = [pageBefore.arryData count] + 1;
		}
		else if ([temp.name compare: [pageBefore.arryData objectAtIndex:counter]] < 0) {
			[pageBefore.arryData insertObject: temp.name atIndex:counter];
			[ptf.foodList insertObject: temp atIndex:counter];
			counter = [pageBefore.arryData count] + 1;
		}
		counter++;
	}
	if (exist == NO) {
		[pageBefore reloading];
		[ptf saveFoodList];
		[self.navBefore popViewControllerAnimated:YES];
	}
	else {
		existence.text = @"Food Exists Already";
	}
	[temp release];		
}

-(IBAction) goNothing {
	[self.navBefore popViewControllerAnimated:YES];
}

- (BOOL)textFieldShouldReturn:(UITextField *)theTextField {
	if (theTextField == name) {
		[name resignFirstResponder];
	}
	else if (theTextField == calories) {
		[calories resignFirstResponder];	
	}
    return YES;
}

-(IBAction) openSearchBrowser {
	[self.navBefore pushViewController:nfs animated:YES];
	[nfs refresh];
}

- (void)motionBegan:(UIEventSubtype)motion withEvent:(UIEvent *)event {
    if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
      [ptf updateCurrentSteps];
    }
}

- (void)motionEnded:(UIEventSubtype)motion withEvent:(UIEvent *)event {
  if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
		[ptf updateHappiness];
	}
}

- (void) viewDidAppear:(BOOL)animated {
    [self becomeFirstResponder];
    [super viewDidAppear:animated];
}

-(BOOL) canBecomeFirstResponder {
	return YES;
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	self.ptf = (PetTrainerFinalAppDelegate *) [[UIApplication sharedApplication] delegate];
	nfs = [[NewFoodSearch alloc] init];
	nfs.navBefore = navBefore;
	nfs.pageBefore = self;
    [super viewDidLoad];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
	[nfs release];
}


@end
