//
//  OnePlayer.m
//  PetTrainerFinal
//
//  Created by Class Account on 4/3/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "OnePlayer.h"
#import "GameController.h"

@implementation OnePlayer

@synthesize ptf, navBefore, pageBefore, nav;
@synthesize bg, pet;

-(void) goBack {
	[self.navBefore popViewControllerAnimated:YES];
}

-(void)scrollView; {
	
	float oldY = self.bg.center.y + kMoveY;
	float newY = oldY;
	
	if (oldY < kBottomY &&
		!pause) {
		
		//NSLog(@"oldY: %f, hurdles float value: %f", oldY, [[hurdles objectAtIndex:numHurdle] floatValue]);
		if (oldY > [[hurdles objectAtIndex:numHurdle] floatValue]) {
			if (self.pet.center.x > (kJumpX+kLandX)/2.0) {
				return;
			} else {
				if (numHurdle < [hurdles count]-1) {
					numHurdle++;
				}
			}
		}
		
		self.bg.center = CGPointMake(self.bg.center.x, newY);
	} else if (!pause) {
		float raceTime = -[startTime timeIntervalSinceNow];
		NSString *points = [NSString stringWithFormat:@"Record time: %1.2f", raceTime];
		NSString *test = [NSString stringWithFormat:@"%1.2f", raceTime];
		ptf.petnews = [[NSString alloc] initWithFormat:@"%@ ran 1-player race in %1.2f seconds!\n%@", ptf.petname, raceTime, ptf.petnews];
    [ptf.localData setObject:ptf.petnews forKey:@"petnews"];
		int counter = 0;
		while (counter <= [ptf.time count]) {
			if (counter == [ptf.time count]) {
				[ptf.time addObject:test];
				counter = [ptf.time count] + 1;
			}
			else if (raceTime < [[ptf.time objectAtIndex:counter] floatValue]) {
				[ptf.time insertObject:test atIndex:counter];
				counter = [ptf.time count] + 1;
			}
			counter++;
		}
    [ptf.localData setObject:ptf.time forKey:@"time"];
		counter = 0;
		UIAlertView *winAlert = [[UIAlertView alloc] initWithTitle:@"You Win!" message:points delegate:self cancelButtonTitle:nil otherButtonTitles: @"DONE", nil];
		[winAlert show];
		pause = YES;
	}
}

-(void)startJumping {
	kMovePetX = -6.0;
	startJump = YES;
}
-(void)jumpPet {
	if (!startJump) {
		return;
	}
	
	float oldX = self.pet.center.x + kMovePetX;
	float newX = oldX;
	
	if (!pause) {
		if (oldX < kJumpX) {
			kMovePetX = 6.0;
		}
		if (oldX > kLandX) {
			startJump = NO;
		}
		self.pet.center = CGPointMake(newX, self.pet.center.y);
	}
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
    //process touches down event
	[self startJumping];
	//NSLog([startTime description]);
	//NSLog(@"since startTime: %f", [startTime timeIntervalSinceNow]);
}

- (void)alertView:(UIAlertView *)alertView clickedButtonAtIndex:(NSInteger)buttonIndex {
	if ([[alertView message] isEqualToString:@"Tap to jump!"]) {
		pause = NO;
		startTime = [[NSDate alloc] init];
		[alertView release];
	} else if ([[alertView title] isEqualToString:@"You Win!"]) {
		[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:YES];
		[self goBack];
	}
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	
	self.ptf = (PetTrainerFinalAppDelegate *) [[UIApplication sharedApplication] delegate];
	[self.view addSubview:[nav view]];
	
    [super viewDidLoad];
	kUpdateRate = 1.0 / 60.0;
	kMoveY = 3.0 + (6.0* (self.ptf.happiness / 10.0)); //min speed = 3.0, max speed = 9.0
	kTopY = -500.0;
	kBottomY = 960.0;
	kMovePetX = -6.0;
	kLandX = 240.0;
	kJumpX = 120.0;
	kStartY= 330.0;
	pause = YES;
	startJump = NO;
	
	hurdles = [[NSArray alloc] initWithObjects:
			   [NSNumber numberWithFloat:-400.0],
			   [NSNumber numberWithFloat:-230.0],
			   [NSNumber numberWithFloat:100.0],
			   [NSNumber numberWithFloat:350.0],
			   [NSNumber numberWithFloat:640.0],
			   [NSNumber numberWithFloat:840.0],
			   [NSNumber numberWithFloat:kBottomY], nil];
	numHurdle = 0;
	
	self.bg = [[UIImageView alloc] initWithImage:[UIImage imageNamed:@"bg01vert.jpg"]];
	[self.view addSubview:self.bg];
	self.bg.center = CGPointMake(self.bg.center.x, kTopY);
	[NSTimer scheduledTimerWithTimeInterval:kUpdateRate target:self selector:@selector(scrollView) userInfo:nil repeats:YES];
	
	self.pet = [[UIImageView alloc] initWithImage:ptf.petpic];
	self.pet.bounds = CGRectMake(0, 0, 108, 118);
	self.pet.contentMode = UIViewContentModeScaleAspectFit;
	[self.view addSubview:self.pet];
	self.pet.transform = CGAffineTransformMakeRotation(-1.57079633); //rotation in radians;
	self.pet.center = CGPointMake(kLandX, kStartY);
	[NSTimer scheduledTimerWithTimeInterval:kUpdateRate target:self selector:@selector(jumpPet) userInfo:nil repeats:YES];	
}

- (void)restartGame {
	[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationLandscapeLeft animated:YES];
	
	UIAlertView *startAlert = [[UIAlertView alloc] initWithTitle:nil message:@"Tap to jump!" delegate:self cancelButtonTitle:nil otherButtonTitles: @"START", nil];
	[startAlert show];
	
	pause = YES;
	startJump = NO;
	numHurdle = 0;
	self.bg.center = CGPointMake(self.bg.center.x, kTopY);
	self.pet.center = CGPointMake(kLandX, kStartY);
	
	self.pet.image = ptf.petpic;
	
	kMoveY = 3.0 + (6.0* (self.ptf.happiness / 10.0)); //min speed = 3.0, max speed = 9.0
}

- (void)motionBegan:(UIEventSubtype)motion withEvent:(UIEvent *)event {
    if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
      [ptf updateCurrentSteps];
    }
}

- (void)motionEnded:(UIEventSubtype)motion withEvent:(UIEvent *)event {
  if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
		[ptf updateHappiness];
	}
}

- (void) viewDidAppear:(BOOL)animated {
    [self becomeFirstResponder];
    [super viewDidAppear:animated];
}

-(BOOL) canBecomeFirstResponder {
	return YES;
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	
	//[self.view addSubview:[nav view]];
}


- (void)dealloc {
    [super dealloc];
	
	[ptf release];
	[navBefore release];
	[pageBefore release];
	[nav release];
	
	[bg release];
	[pet release];
	
	[hurdles release];
	
	[startTime release];
}


@end
