//
//  PetTrainerFinalAppDelegate.m
//  PetTrainerFinal
//
//  Created by Tomomasa Terazaki on 3/31/10.
//  Copyright UC Berkeley 2010. All rights reserved.
//

#import "PetTrainerFinalAppDelegate.h"
#import "HomeSettingController.h"
#import "Food.h"

@implementation PetTrainerFinalAppDelegate

@synthesize window;
@synthesize tabBarController;
@synthesize petname, petsex, petmonth, petday, petyear, petheightfeet, petheightinch, petweight, petmood, peteatmood, foodname, hsc, petpic, petnews, petWalkNews, steps, currentSteps, totalSteps, totalCalories, happiness, eatHappiness, walkHappiness, foodList, tempFood, time, petTime, localData;

- (void)applicationDidFinishLaunching:(UIApplication *)application {
    
	//[application setStatusBarOrientation:UIInterfaceOrientationLandscapeLeft animated:NO];
	
    // Add the tab bar controller's current view as a subview of the window
	[[UIApplication sharedApplication] setStatusBarHidden:YES];
    [window addSubview:tabBarController.view];
  
  localData = [NSUserDefaults standardUserDefaults];
  
  if ([localData boolForKey:@"setupComplete"]) {
    petpic = [UIImage imageNamed:[localData stringForKey:@"petpic"]];
    petname = [localData stringForKey:@"petname"];
	petmood = [localData stringForKey:@"petmood"];
	peteatmood = [localData stringForKey:@"peteatmood"];
    petsex = [localData stringForKey:@"petsex"];
    petmonth = [localData stringForKey:@"petmonth"];
    petday = [localData stringForKey:@"petday"];
    petyear = [localData stringForKey:@"petyear"];
    petheightfeet = [localData stringForKey:@"petheightfeet"];
    petheightinch = [localData stringForKey:@"petheightinch"];
    petweight = [localData stringForKey:@"petweight"];
    petnews = [localData stringForKey:@"petnews"];
    petWalkNews = [localData stringForKey:@"petWalkNews"];
    steps = [localData boolForKey:@"steps"];
    currentSteps = [localData integerForKey:@"currentSteps"];
    totalSteps = [localData integerForKey:@"totalSteps"];
	totalCalories = [localData integerForKey:@"totalCalories"];
	happiness = [localData integerForKey:@"happiness"];
    happiness = [localData integerForKey:@"happiness"];
    eatHappiness = [localData integerForKey:@"eatHappiness"];
    walkHappiness = [localData integerForKey:@"walkHappiness"];
    petTime = [localData stringForKey:@"petTime"];
    time = [[NSMutableArray alloc] init];
    foodList = [[NSMutableArray alloc] init];
    [time setArray:[localData stringArrayForKey:@"time"]];
	  [self loadFoodList];
  } else {
    petpic = [UIImage imageNamed:@"dog.png"];
    petname = @"David";
    petmood = @" wants to exercise";
	peteatmood = @" and eat more";
    petsex = @"Male";
    petmonth = @"10";
    petday = @"19";
    petyear = @"1989";
    petheightfeet = @"5";
    petheightinch = @"8";
    petweight = @"160";
    petnews = @"";
    petWalkNews = @"";
    steps = NO;
    currentSteps = 0;
    totalSteps = 0;
    totalCalories = 0;
    happiness = 0;
    eatHappiness = 0;
    walkHappiness = 0;
    petTime = @"";
    time = [[NSMutableArray alloc] init];
    foodList = [[NSMutableArray alloc] init];
    Food *apple = [[Food alloc] init];
    apple.name = @"Apple";
    apple.calories = 72;
    [foodList addObject:apple];
    [apple release];
    Food *avocado = [[Food alloc] init];
    avocado.name = @"Avocado";
    avocado.calories = 276;
    [foodList addObject:avocado];
    [avocado release];
    Food *banana = [[Food alloc] init];
    banana.name = @"Banana";
    banana.calories = 105;
    [foodList addObject:banana];
    [banana release];
    Food *cheddar = [[Food alloc] init];
    cheddar.name = @"Cheddar Cheese (1 Slice)";
    cheddar.calories = 113;
    [foodList addObject:cheddar];
    [cheddar release];
    Food *colby = [[Food alloc] init];
    colby.name = @"Colby Cheese (1 Slice)";
    colby.calories = 110;
    [foodList addObject:colby];
    [colby release];
    Food *egg = [[Food alloc] init];
    egg.name = @"Egg";
    egg.calories = 78;
    [foodList addObject:egg];
    [egg release];
    Food *grape = [[Food alloc] init];
    grape.name = @"Grape";
    grape.calories = 103;
    [foodList addObject:grape];
    [grape release];
    Food *grapefruit = [[Food alloc] init];
    grapefruit.name = @"Grapefruit";
    grapefruit.calories = 82;
    [foodList addObject:grapefruit];
    [grapefruit release];
    Food *kiwi = [[Food alloc] init];
    kiwi.name = @"Kiwi";
    kiwi.calories = 46;
    [foodList addObject:kiwi];
    [kiwi release];
    Food *mango = [[Food alloc] init];
    mango.name = @"Mango";
    mango.calories = 91;
    [foodList addObject:mango];
    [mango release];
    Food *melon = [[Food alloc] init];
    melon.name = @"Melon";
    melon.calories = 46;
    [foodList addObject:melon];
    [melon release];
    Food *milk0 = [[Food alloc] init];
    milk0.name = @"Milk (0%)";
    milk0.calories = 83;
    [foodList addObject:milk0];
    [milk0 release];
    Food *milk1 = [[Food alloc] init];
    milk1.name = @"Milk (1%)";
    milk1.calories = 102;
    [foodList addObject:milk1];
    [milk1 release];
    Food *milk2 = [[Food alloc] init];
    milk2.name = @"Milk (2%)";
    milk2.calories = 122;
    [foodList addObject:milk2];
    [milk2 release];
    Food *orange = [[Food alloc] init];
    orange.name = @"Orange";
    orange.calories = 71;
    [foodList addObject:orange];
    [orange release];
    Food *peach = [[Food alloc] init];
    peach.name = @"Peach";
    peach.calories = 58;
    [foodList addObject:peach];
    [peach release];
    Food *pear = [[Food alloc] init];
    pear.name = @"Pear";
    pear.calories = 98;
    [foodList addObject:pear];
    [pear release];
    Food *pinapple = [[Food alloc] init];
    pinapple.name = @"Pinapple";
    pinapple.calories = 80;
    [foodList addObject:pinapple];
    [pinapple release];
    Food *pizzac = [[Food alloc] init];
    pizzac.name = @"Pizza (Cheese 1 Slice)";
    pizzac.calories = 140;
    [foodList addObject:pizzac];
    [pizzac release];
    Food *pizzap = [[Food alloc] init];
    pizzap.name = @"Pizza (Pepperoni 1 Slice)";
    pizzap.calories = 181;
    [foodList addObject:pizzap];
    [pizzap release];
    Food *plum = [[Food alloc] init];
    plum.name = @"Plum";
    plum.calories = 36;
    [foodList addObject:plum];
    [plum release];	
    Food *strawberry = [[Food alloc] init];
    strawberry.name = @"Strawberry";
    strawberry.calories = 45;
    [foodList addObject:strawberry];
    [strawberry release];
    Food *watermelon = [[Food alloc] init];
    watermelon.name = @"Watermelon";
    watermelon.calories = 46;
    [foodList addObject:watermelon];
    [watermelon release];
    [localData setBool:YES forKey:@"setupComplete"];
    [localData setObject:@"dog.png" forKey:@"petpic"];
    [localData setObject:petname forKey:@"petname"];
    [localData setObject:petmood forKey:@"petmood"];
	[localData setObject:peteatmood forKey:@"peteatmood"];
    [localData setObject:petsex forKey:@"petsex"];
    [localData setObject:petmonth forKey:@"petmonth"];
    [localData setObject:petday forKey:@"petday"];
    [localData setObject:petyear forKey:@"petyear"];
    [localData setObject:petheightfeet forKey:@"petheightfeet"];
    [localData setObject:petheightinch forKey:@"petheightinch"];
    [localData setObject:petweight forKey:@"petweight"];
    [localData setObject:petnews forKey:@"petnews"];
    [localData setObject:petWalkNews forKey:@"petWalkNews"];
    [localData setBool:steps forKey:@"steps"];
    [localData setInteger:currentSteps forKey:@"currentSteps"];
    [localData setInteger:totalSteps forKey:@"totalSteps"];
    [localData setInteger:totalCalories forKey:@"totalCalories"];
    [localData setInteger:happiness forKey:@"happiness"];
    [localData setInteger:eatHappiness forKey:@"eatHappiness"];
    [localData setInteger:walkHappiness forKey:@"walkHappiness"];
    [localData setObject:petTime forKey:@"petTime"];
    [localData setObject:time forKey:@"time"];
	if ([localData stringArrayForKey:@"foodList"] == nil) {
		[self saveFoodList];
	}
  }
}


-(void) loadFoodList {
	[foodList removeAllObjects];
    NSArray *foodData = [localData stringArrayForKey:@"foodList"];
	for (NSString *data in foodData) {
		NSArray *items = [data componentsSeparatedByString:@"_"];
		Food *foodTemp = [[Food alloc] init];
		foodTemp.name = [items objectAtIndex:0];
		NSString *c = [items objectAtIndex:1];
		foodTemp.calories = [c intValue];
		[foodList addObject:foodTemp];
		[foodTemp release];
	}
}

-(void) saveFoodList {
	NSMutableArray *foodData = [[NSMutableArray alloc] init];
	for (Food *foodTemp in foodList) {
		NSString *foodString = [NSString stringWithFormat:@"%@_%d", foodTemp.name, foodTemp.calories];
		[foodData addObject:foodString];
	}
	NSArray *foodArray = [[NSArray alloc] initWithArray:foodData copyItems:YES];
	[localData setObject:foodArray forKey:@"foodList"];
}

-(void) updateCurrentSteps {
  currentSteps++;
  [localData setInteger:currentSteps forKey:@"currentSteps"];
}

-(void) updateHappiness {
  if (currentSteps + totalSteps < 3000) {
    walkHappiness = 0;
    happiness = walkHappiness + eatHappiness;
  }
  else if (currentSteps + totalSteps < 6000) {
    walkHappiness = 1;
    happiness = walkHappiness + eatHappiness;
  }
  else if (currentSteps + totalSteps < 9000) {
    walkHappiness = 2;
    happiness = walkHappiness + eatHappiness;
  }
  else if (currentSteps + totalSteps < 12000) {
    walkHappiness = 3;
    happiness = walkHappiness + eatHappiness;
  }
  else if (currentSteps + totalSteps < 15000) {
    walkHappiness = 4;
    happiness = walkHappiness + eatHappiness;
  }
  else if (currentSteps + totalSteps >= 20000) {
    walkHappiness = 5;
    happiness = walkHappiness + eatHappiness;
  }
  [localData setInteger:happiness forKey:@"happiness"];
  [localData setInteger:eatHappiness forKey:@"eatHappiness"];
  [localData setInteger:walkHappiness forKey:@"walkHappiness"];
}


// Optional UITabBarControllerDelegate method
- (void)tabBarController:(UITabBarController *)tabBarController didSelectViewController:(UIViewController *)viewController {
	
	if ([[viewController title] isEqualToString:@"Game"]) {
		//[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationLandscapeLeft animated:NO];
	} else {
		[[UIApplication sharedApplication] setStatusBarOrientation:UIInterfaceOrientationPortrait animated:YES];
	}
}


/*
// Optional UITabBarControllerDelegate method
- (void)tabBarController:(UITabBarController *)tabBarController didEndCustomizingViewControllers:(NSArray *)viewControllers changed:(BOOL)changed {
}
*/


- (void)dealloc {
    [tabBarController release];
    [window release];
    [super dealloc];
}

@end

