//
//  GameController.m
//  PetTrainerFinal
//
//  Created by Tomomasa Terazaki on 3/31/10.
//  Copyright 2010 UC Berkeley. All rights reserved.
//

#import "GameController.h"


@implementation GameController

@synthesize ptf, nav, op, tp, leftImage, rightImage, gs;

-(IBAction) goOnePlayer {
	[self.nav pushViewController:op animated:YES];
	[op restartGame];
}

-(IBAction) goTwoPlayer {
	[self.nav pushViewController:tp animated:YES];
	[tp restartGame];
} 

-(IBAction) goHistory {
	[self presentModalViewController:gs animated:YES];
}

- (void)motionBegan:(UIEventSubtype)motion withEvent:(UIEvent *)event {
    if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
      [ptf updateCurrentSteps];
    }
}

- (void)motionEnded:(UIEventSubtype)motion withEvent:(UIEvent *)event {
  if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
		[ptf updateHappiness];
	}
}

- (void) viewDidAppear:(BOOL)animated {
    [self becomeFirstResponder];
    [super viewDidAppear:animated];
}

-(BOOL) canBecomeFirstResponder {
	return YES;
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

-(void) viewWillAppear:(BOOL)animated {
	self.leftImage.image = ptf.petpic;
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	[self.view addSubview:[nav view]];
	self.ptf = (PetTrainerFinalAppDelegate *) [[UIApplication sharedApplication] delegate];
	op = [[OnePlayer alloc] init];
	op.navBefore = nav;
	op.pageBefore = self;
	tp = [[TwoPlayer alloc] init];
	tp.navBefore = nav;
	tp.pageBefore = self;
	
	gs = [[GameScore alloc] init];
    [super viewDidLoad];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
	[ptf release];
	[nav release];
	[op release];
	[tp release];
	
	[leftImage release];
	[rightImage release];
}


@end
