//
//  HomeController.m
//  PetTrainerFinal
//
//  Created by Tomomasa Terazaki on 3/31/10.
//  Copyright 2010 UC Berkeley. All rights reserved.
//

#import "HomeController.h"

@implementation HomeController

@synthesize ptf, name, sex, bday, height, weight, mood, news, face, nav, hsc, animalPic, help, fc;

-(IBAction) goSetting {
	[self.nav pushViewController:hsc animated:YES];
}

-(IBAction) goHelp {
	[self.nav pushViewController:help animated:YES];
	help.navBefore = self.nav;
}

-(void) change {
	name.text =  [[NSString alloc] initWithFormat:@"%@'s Page!", ptf.petname];
	bday.text =  [[NSString alloc] initWithFormat:@"Birthday: %@/%@/%@", ptf.petmonth, ptf.petday, ptf.petyear];
	height.text = [[NSString alloc] initWithFormat:@"Height: %@'%@''", ptf.petheightfeet, ptf.petheightinch];
	weight.text = [[NSString alloc] initWithFormat:@"Weight: %@ lbs", ptf.petweight];
	sex.text = [[NSString alloc] initWithFormat:@"Sex: %@", ptf.petsex];
	[fc reloading];
	if (ptf.peteatmood == NULL) {
		mood.text = [[NSString alloc] initWithFormat:@"%@%@", ptf.petname, ptf.petmood];
	}
	else {
		mood.text = [[NSString alloc] initWithFormat:@"%@%@%@", ptf.petname, ptf.petmood, ptf.peteatmood];
	}
	animalPic.image = ptf.petpic;
	if (news == nil) {
		news = @"";
	}
	news.text = [[NSString alloc] initWithFormat:@"%@", ptf.petnews];
	if (ptf.happiness < 4) {
		face.image = [UIImage imageNamed:@"face1.jpg"];
	}
	else if (ptf. happiness < 7) {
		face.image = [UIImage imageNamed:@"face2.jpg"];
	}
	else {
		face.image = [UIImage imageNamed:@"face3.jpg"];
	}
}

- (void)motionBegan:(UIEventSubtype)motion withEvent:(UIEvent *)event {
    if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
      [ptf updateCurrentSteps];
    }
}

- (void)motionEnded:(UIEventSubtype)motion withEvent:(UIEvent *)event {
  if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
		[ptf updateHappiness];
	}
}

- (void) viewDidAppear:(BOOL)animated {
    [self becomeFirstResponder];
    [super viewDidAppear:animated];
}

-(BOOL) canBecomeFirstResponder {
	return YES;
}

-(void) viewWillAppear:(BOOL)animated {
	[self change];
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	self.ptf = (PetTrainerFinalAppDelegate *) [[UIApplication sharedApplication] delegate];
	[self.view addSubview:[nav view]];
	hsc = [[HomeSettingController alloc] init];
	help = [[ReadMeMain alloc] init];
	hsc.navBefore = nav;
	hsc.pageBefore = self;
	fc = [[FeedController alloc] init];
    [super viewDidLoad];
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc {
	[name release];
	[sex release];
	[bday release];
	[height release];
	[weight release];
	[mood release];
	[news release];
	[nav release];
    [super dealloc];
}

@end
