//
//  HomeSettingController.m
//  PetTrainerFinal
//
//  Created by Tomomasa Terazaki on 3/31/10.
//  Copyright 2010 UC Berkeley. All rights reserved.
//

#import "HomeSettingController.h"
#import "HomeController.h"

@implementation HomeSettingController

@synthesize ptf, month, year, day, sex, heightfeet, heightinch, weight, name, navBefore, pageBefore, nav, ca, wrc;

-(IBAction) goBack {
	[self.pageBefore change];
	[wrc changePic];
	wrc.pic.image = ptf.petpic;
	[self.navBefore popViewControllerAnimated:YES];
}

-(IBAction) sexChange {
	if ([sex selectedSegmentIndex] == 0) {
		ptf.petsex = @"Male";
		ptf.petnews = [[NSString alloc] initWithFormat:@"%@ is infused with testosterone\n%@", ptf.petname, ptf.petnews];
	}
	else {
		ptf.petsex = @"Female";
		ptf.petnews = [[NSString alloc] initWithFormat:@"%@ had a sex change\n%@", ptf.petname, ptf.petnews];
	}
  [ptf.localData setObject:ptf.petsex forKey:@"petsex"];
  [ptf.localData setObject:ptf.petnews forKey:@"petnews"];
}

-(IBAction) nameChange {
	if (ptf.petname != name.text) {
		ptf.petnews = [[NSString alloc] initWithFormat:@"%@ changed name to %@\n%@", ptf.petname, name.text, ptf.petnews];
	}
	ptf.petname = name.text;
}

-(IBAction) newAnimal {
	[self.nav pushViewController:ca animated:YES];
}

- (BOOL)textFieldShouldReturn:(UITextField *)theTextField {
	if (theTextField == month) {
		[month resignFirstResponder];
	}
	else if (theTextField == day) {
		[day resignFirstResponder];
	}
	else if (theTextField == year) {
		[year resignFirstResponder];
	}
	else if (theTextField == heightfeet) {
		[heightfeet resignFirstResponder];
	}
	else if (theTextField == heightinch) {
		[heightinch resignFirstResponder];
	}
	else if (theTextField == weight) {
		[weight resignFirstResponder];
	}
	else if (theTextField == name) {
		[name resignFirstResponder];
	}
	ptf.petmonth = month.text;
	ptf.petday = day.text;
	ptf.petyear = year.text;
	ptf.petheightfeet = heightfeet.text;
	ptf.petheightinch = heightinch.text;
	if ([ptf.petweight intValue] < [weight.text intValue]) {
		ptf.petnews = [[NSString alloc] initWithFormat:@"%@ gained weight\n%@", ptf.petname, ptf.petnews];
	}
	else if ([ptf.petweight intValue] > [weight.text intValue]) {
		ptf.petnews = [[NSString alloc] initWithFormat:@"%@ lost weight\n%@", ptf.petname, ptf.petnews];
	}
	ptf.petweight = weight.text;
	ptf.petname = name.text;
  [ptf.localData setObject:ptf.petname forKey:@"petname"];
  [ptf.localData setObject:ptf.petnews forKey:@"petnews"];
  [ptf.localData setObject:ptf.petmonth forKey:@"petmonth"];
  [ptf.localData setObject:ptf.petday forKey:@"petday"];
  [ptf.localData setObject:ptf.petyear forKey:@"petyear"];
  [ptf.localData setObject:ptf.petheightfeet forKey:@"petheightfeet"];
  [ptf.localData setObject:ptf.petheightinch forKey:@"petheightinch"];
  return YES;
}

-(IBAction) reset {
	UIAlertView *resetAlert = [[UIAlertView alloc] initWithTitle:nil message:@"Delete all history and reset stats?" delegate:self cancelButtonTitle:@"Yes, reset" otherButtonTitles:@"Cancel",nil];
	[resetAlert show];
	[resetAlert release];
}

- (void)alertView:(UIAlertView *)actionSheet clickedButtonAtIndex:(NSInteger)buttonIndex {
	if (buttonIndex == 0 && actionSheet.numberOfButtons == 2) {
		[ptf.localData removeObjectForKey:@"setupComplete"];
		[ptf.localData removeObjectForKey:@"foodData"];
		UIAlertView *alert = [[UIAlertView alloc] initWithTitle:nil message:@"App must be restarted for changes to take effect." delegate:self cancelButtonTitle:@"OK" otherButtonTitles:nil,nil];
		[alert show];
		[alert release];
	}
}

- (void)motionBegan:(UIEventSubtype)motion withEvent:(UIEvent *)event {
    if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
      [ptf updateCurrentSteps];
    }
}

- (void)motionEnded:(UIEventSubtype)motion withEvent:(UIEvent *)event {
  if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
		[ptf updateHappiness];
	}
}

- (void) viewDidAppear:(BOOL)animated {
    [self becomeFirstResponder];
    [super viewDidAppear:animated];
}

-(BOOL) canBecomeFirstResponder {
	return YES;
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	self.ptf = (PetTrainerFinalAppDelegate *) [[UIApplication sharedApplication] delegate];
	ptf.petname = name.text;
	ptf.petmonth = month.text;
	ptf.petday = day.text;
	ptf.petyear = year.text;
	ptf.petheightfeet = heightfeet.text;
	ptf.petheightinch = heightinch.text;
	ptf.petweight = weight.text;
	if ([sex selectedSegmentIndex] == 0) {
		ptf.petsex = @"Male";
	}
	else {
		ptf.petsex = @"Female";
	}
	[self.view addSubview:[nav view]];
	ca = [[ChooseAnimal alloc] init];
	ca.navBefore = nav;
	ca.pageBefore = self;
	wrc = [[WalkRunController alloc] init];
    [super viewDidLoad];
  [ptf.localData setObject:ptf.petname forKey:@"petname"];
  [ptf.localData setObject:ptf.petnews forKey:@"petnews"];
  [ptf.localData setObject:ptf.petmonth forKey:@"petmonth"];
  [ptf.localData setObject:ptf.petday forKey:@"petday"];
  [ptf.localData setObject:ptf.petyear forKey:@"petyear"];
  [ptf.localData setObject:ptf.petheightfeet forKey:@"petheightfeet"];
  [ptf.localData setObject:ptf.petheightinch forKey:@"petheightinch"];
  [ptf.localData setObject:ptf.petsex forKey:@"petsex"];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc {
	[ptf release];
	[month release];
	[year release];
	[day release]; 
	[sex release];
	[heightfeet release];
	[heightinch release];
	[weight release];
	[name release];
	[navBefore release];
	[pageBefore release];
    [super dealloc];
}


@end
