//
//  WalkRunController.m
//  PetTrainerFinal
//
//  Created by Tomomasa Terazaki on 3/31/10.
//  Copyright 2010 UC Berkeley. All rights reserved.
//

#import "WalkRunController.h"

@implementation WalkRunController

@synthesize ptf, step, mood, wrh, pic;

-(IBAction) saveSteps {
	if (ptf.currentSteps > 0) {
		if (ptf.currentSteps == 1) {
			ptf.petnews = [[NSString alloc] initWithFormat:@"%@ took %d step\n%@", ptf.petname, ptf.currentSteps, ptf.petnews];
			ptf.petWalkNews = [[NSString alloc] initWithFormat:@"You took %d step\n%@", ptf.currentSteps, ptf.petWalkNews];
		}
		else {
			ptf.petnews = [[NSString alloc] initWithFormat:@"%@ took %d steps\n%@", ptf.petname, ptf.currentSteps, ptf.petnews];
			ptf.petWalkNews = [[NSString alloc] initWithFormat:@"You took %d steps\n%@", ptf.currentSteps, ptf.petWalkNews];
		}
		ptf.totalSteps += ptf.currentSteps;
		ptf.currentSteps = 0;
    [ptf.localData setObject:ptf.petnews forKey:@"petnews"];
    [ptf.localData setObject:ptf.petWalkNews forKey:@"petWalkNews"];
    [ptf.localData setInteger:ptf.totalSteps forKey:@"totalSteps"];
    [ptf.localData setInteger:ptf.currentSteps forKey:@"currentSteps"];
		step.text = [[NSString alloc] initWithFormat:@"%d", ptf.currentSteps];
	}
}	

-(IBAction) goHistory {
	[self presentModalViewController:wrh animated:YES];
}

- (void)motionBegan:(UIEventSubtype)motion withEvent:(UIEvent *)event {
    if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
      [ptf updateCurrentSteps];
    } 
}

- (void)motionEnded:(UIEventSubtype)motion withEvent:(UIEvent *)event {
    if (event.type == UIEventTypeMotion && event.subtype == UIEventSubtypeMotionShake) {
        step.text = [[NSString alloc] initWithFormat:@"%d", ptf.currentSteps];
		if (ptf.currentSteps + ptf.totalSteps < 3000) {
			ptf.petmood = @" wants to walk a lot more";
			ptf.walkHappiness = 0;
			ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			mood.text = [[NSString alloc] initWithFormat:@"%@%@\nTry to take %d steps", ptf.petname, ptf.petmood, 12000 - ptf.totalSteps];
		}
		else if (ptf.currentSteps + ptf.totalSteps < 6000) {
			ptf.petmood = @" needs to walk more";
			ptf.walkHappiness = 1;
			ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			mood.text = [[NSString alloc] initWithFormat:@"%@%@\nTry to take %d steps", ptf.petname, ptf.petmood, 12000 - ptf.totalSteps];
		}
		else if (ptf.currentSteps + ptf.totalSteps < 9000) {
			ptf.petmood = @" walked a lot but not enough";
			ptf.walkHappiness = 2;
			ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			mood.text = [[NSString alloc] initWithFormat:@"%@%@\nTry to take %d steps", ptf.petname, ptf.petmood, 12000 - ptf.totalSteps];
		}
		else if (ptf.currentSteps + ptf.totalSteps < 12000) {
			ptf.petmood = @" feels great";
			ptf.walkHappiness = 3;
			ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			mood.text = [[NSString alloc] initWithFormat:@"%@%@\nHave a Great Day!", ptf.petname, ptf.petmood];
		}
		else if (ptf.currentSteps + ptf.totalSteps < 15000) {
			ptf.petmood = @" is having a healthy day";
			ptf.walkHappiness = 4;
			ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			mood.text = [[NSString alloc] initWithFormat:@"%@%@\nHave an Awesome Day!", ptf.petname, ptf.petmood];
			
		}
		else if (ptf.currentSteps + ptf.totalSteps >= 20000) {
			ptf.petmood = @" is a super star";
			ptf.walkHappiness = 5;
			ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
			mood.text = [[NSString alloc] initWithFormat:@"%@%@\nYou Are The BEST!", ptf.petname, ptf.petmood];
		}	
	}
  [ptf.localData setObject:ptf.petmood forKey:@"petmood"];
  [ptf.localData setInteger:ptf.happiness forKey:@"happiness"];
  [ptf.localData setInteger:ptf.eatHappiness forKey:@"eatHappiness"];
  [ptf.localData setInteger:ptf.walkHappiness forKey:@"walkHappiness"];
	[self changePic];
}

-(void) viewWillAppear:(BOOL)animated {
	[self changePic];
	if (ptf.currentSteps + ptf.totalSteps < 3000) {
		ptf.petmood = @" wants to walk a lot more";
		ptf.walkHappiness = 0;
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
		mood.text = [[NSString alloc] initWithFormat:@"%@%@\nTry to take %d steps", ptf.petname, ptf.petmood, 12000 - ptf.totalSteps];
	}
	else if (ptf.currentSteps + ptf.totalSteps < 6000) {
		ptf.petmood = @" needs to walk more";
		ptf.walkHappiness = 1;
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
		mood.text = [[NSString alloc] initWithFormat:@"%@%@\nTry to take %d steps", ptf.petname, ptf.petmood, 12000 - ptf.totalSteps];
	}
	else if (ptf.currentSteps + ptf.totalSteps < 9000) {
		ptf.petmood = @" walked a lot but not enough";
		ptf.walkHappiness = 2;
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
		mood.text = [[NSString alloc] initWithFormat:@"%@%@\nTry to take %d steps", ptf.petname, ptf.petmood, 12000 - ptf.totalSteps];
	}
	else if (ptf.currentSteps + ptf.totalSteps < 12000) {
		ptf.petmood = @" feels great";
		ptf.walkHappiness = 3;
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
		mood.text = [[NSString alloc] initWithFormat:@"%@%@\nHave a Great Day!", ptf.petname, ptf.petmood];
	}
	else if (ptf.currentSteps + ptf.totalSteps < 15000) {
		ptf.petmood = @" is having a healthy day";
		ptf.walkHappiness = 4;
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
		mood.text = [[NSString alloc] initWithFormat:@"%@%@\nHave an Awesome Day!", ptf.petname, ptf.petmood];

	}
	else if (ptf.currentSteps + ptf.totalSteps >= 20000) {
		ptf.petmood = @" is a super star";
		ptf.walkHappiness = 5;
		ptf.happiness = ptf.walkHappiness + ptf.eatHappiness;
		mood.text = [[NSString alloc] initWithFormat:@"%@%@\nYou Are The BEST!", ptf.petname, ptf.petmood];
	}
  [ptf.localData setObject:ptf.petmood forKey:@"petmood"];
  [ptf.localData setInteger:ptf.happiness forKey:@"happiness"];
  [ptf.localData setInteger:ptf.eatHappiness forKey:@"eatHappiness"];
  [ptf.localData setInteger:ptf.walkHappiness forKey:@"walkHappiness"];
	step.text = [[NSString alloc] initWithFormat:@"%d", ptf.currentSteps];
}

- (void) viewDidAppear:(BOOL)animated {
    [self becomeFirstResponder];
    [super viewDidAppear:animated];
}

-(BOOL) canBecomeFirstResponder {
	return YES;
}

-(void) changePic {
	if (ptf.currentSteps % 8 == 0) {
		pic.image = [UIImage imageNamed:@"doganime1.png"];
	}
	else if (ptf.currentSteps % 8 == 1) {
		pic.image = [UIImage imageNamed:@"doganime2.png"];
	}
	else if (ptf.currentSteps % 8 == 2) {
		pic.image = [UIImage imageNamed:@"doganime3.png"];
	}
	else if (ptf.currentSteps % 8 == 3) {
		pic.image = [UIImage imageNamed:@"doganime4.png"];
	}
	else if (ptf.currentSteps % 8 == 4) {
		pic.image = [UIImage imageNamed:@"doganime5.png"];
	}
	else if (ptf.currentSteps % 8 == 5) {
		pic.image = [UIImage imageNamed:@"doganime6.png"];
	}
	else if (ptf.currentSteps % 8 == 6) {
		pic.image = [UIImage imageNamed:@"doganime7.png"];
	}
	else {
		pic.image = [UIImage imageNamed:@"doganime8.png"];
	}
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
	self.ptf = (PetTrainerFinalAppDelegate *) [[UIApplication sharedApplication] delegate];
	wrh = [[WalkRunHistory alloc] init];
    [super viewDidLoad];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
